Enumeration
 #Window
 #XML 
 #File
 #Image_CharView
EndEnumeration

Enumeration
 #Gadget
 #Gadget_ImageArea
 #Gadget_Image
 #Gadget_ImageView
 #Gadget_Index
 #Gadget_Source_X
 #Gadget_Source_Y
 #Gadget_Source_Width
 #Gadget_Source_Height
 #Gadget_Outlay_X
 #Gadget_Outlay_Y
 #Gadget_Outlay_Width
 #Gadget_Outlay_Height
EndEnumeration

Enumeration
 #Menu
 #MenuItem_New
 #MenuItem_Load
 #MenuItem_Save
 #MenuItem_Import
 #MenuItem_Export
 #MenuItem_Quit
EndEnumeration



#Window_Width  = 800
#Window_Height = 600


UsePNGImageEncoder()
UsePNGImageDecoder()

 XIncludeFile "Typeface.pbi"


Global TypefaceCharacterSet.TypefaceCharacterSet
Global GlobalIndex

 Procedure.s GetNamePart(FullPathName$)
  If GetExtensionPart(FullPathName$)
   ProcedureReturn Left(GetFilePart(FullPathName$), Len(GetFilePart(FullPathName$))-Len(GetExtensionPart(FullPathName$))-1)
  Else
   ProcedureReturn GetFilePart(FullPathName$)
  EndIf
 EndProcedure
 
 
 
 ; Ldt eine Font mit ClearTyp
 Procedure LoadClearTypeFont(Name$, Size.i, Style=0)
  Protected LogFont.LOGFONT 
  With LogFont
   \lfHeight         = -Size
   \lfWidth          = 0
   \lfEscapement     = 0
   \lfOrientation    = 0 
   If Style & #PB_Font_Bold       : \lfWeight = 700 : Else : \lfWeight = 400 : EndIf
   If Style & #PB_Font_Italic     : \lfItalic = #True : Else : \lfItalic = #False : EndIf  
   If Style & #PB_Font_Underline  : \lfUnderline = #True : Else : \lfUnderline = #False : EndIf  
   If Style & #PB_Font_StrikeOut  : \lfStrikeOut = #True : Else : \lfStrikeOut = #False : EndIf  
   \lfCharSet        = #DEFAULT_CHARSET
   \lfOutPrecision   = #OUT_DEFAULT_PRECIS	
   \lfClipPrecision  = #CLIP_DEFAULT_PRECIS 
   \lfQuality        = #CLEARTYPE_QUALITY
   \lfPitchAndFamily = #DEFAULT_PITCH | #FF_DONTCARE 
   PokeS(@\lfFaceName[0], Name$) 
  EndWith
  ProcedureReturn CreateFontIndirect_(@LogFont) 
 EndProcedure

Procedure CreateTypeface()
 Protected FontID = LoadClearTypeFont(SelectedFontName(), SelectedFontSize(), SelectedFontStyle())
 Protected Color = SelectedFontColor()+$FF<<24
 Protected TempImage = CreateImage(#PB_Any, 32, 32)
 Protected Index, Width, Height
 StartDrawing(ImageOutput(TempImage))
  DrawingFont(FontID)
  For Index = 32 To 255
   If TextWidth(Chr(Index)) > Width : Width = TextWidth(Chr(Index)) : EndIf
   If TextHeight(Chr(Index)) > Height : Height = TextHeight(Chr(Index)) : EndIf
  Next
 StopDrawing()
 FreeImage(TempImage)
 Select Width
  Case  0 To 14 : Width = 16
  Case 15 To 30 : Width = 32
  Case 31 To 62 : Width = 64
 EndSelect 
 Select Height
  Case  0 To 14 : Height = 16
  Case 15 To 30 : Height = 32
  Case 31 To 62 : Height = 64
 EndSelect 
 ClearStructure(TypefaceCharacterSet, TypefaceCharacterSet)
       ClearGadgetItems(#Gadget_Index)
TypefaceCharacterSet\Sprite = CreateImage(#PB_Any, Width*16, Height*16, 32|#PB_Image_Transparent)
 StartDrawing(ImageOutput(TypefaceCharacterSet\Sprite))
  For Index = 32 To 255
   DrawingFont(FontID)
   DrawingMode(#PB_2DDrawing_AlphaBlend|#PB_2DDrawing_Transparent)
   With TypefaceCharacterSet\Character[Index]
    \Exists = 1
    AddGadgetItem(#Gadget_Index, -1, Str(Index))
    \Outlay\x = -1
    \Outlay\y = -1
    \Outlay\Width = TextWidth(Chr(Index))
    \Outlay\Height = TextHeight(Chr(Index))
    \Source\Width = Width
    \Source\Height = Height
    \Source\x = (Index%16)*Width
    \Source\y = Int(Index/16)*Height
   EndWith
   DrawText((Index%16)*Width+1, Int(Index/16)*Height+1, Chr(Index)+" ", Color, $00000000)
  Next
 StopDrawing()
 ProcedureReturn #True
EndProcedure




OpenWindow(#Window, 0, 0, #Window_Width, #Window_Height+MenuHeight(), "Fenster", #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
 CreateMenu(#Menu, WindowID(#Window))
  MenuTitle("Datei")
  OpenSubMenu("Neu")
   MenuItem(#MenuItem_New, "Aus TTF-Schiftart")
  CloseSubMenu() 
  MenuItem(#MenuItem_Load, "Laden")
  MenuItem(#MenuItem_Save, "Speichern")
  MenuBar()
  OpenSubMenu("Importieren")
   MenuItem(#MenuItem_Import, "Aus XML mit PNG")
  CloseSubMenu()
  OpenSubMenu("Exportieren")
   MenuItem(#MenuItem_Export, "Als XML mit PNG")
  CloseSubMenu()
  MenuBar()
  MenuItem(#MenuItem_Quit, "Beenden")

 ScrollAreaGadget(#Gadget_ImageArea, 200, 0, 600, 600, 0, 0) 
  ImageGadget(#Gadget_Image, 0, 0, 0, 0, 0)
 CloseGadgetList()
 
 TextGadget(#PB_Any, 10, 14, 90, 16, "Buchstabenindex:")
 ComboBoxGadget(#Gadget_Index, 110, 10, 80, 20)

 Frame3DGadget(#PB_Any, 10, 50, 180, 180, "Quelle")
  TextGadget(#PB_Any, 20, 84, 70, 16, "X:") : StringGadget(#Gadget_Source_X, 100,80,80,20,"")
  TextGadget(#PB_Any, 20, 114, 70, 16, "Y:") : StringGadget(#Gadget_Source_Y, 100,110,80,20,"")
  TextGadget(#PB_Any, 20, 144, 70, 16, "Width:") : StringGadget(#Gadget_Source_Width, 100,140,80,20,"")
  TextGadget(#PB_Any, 20, 174, 70, 16, "Height:") : StringGadget(#Gadget_Source_Height, 100,170,80,20,"")

 Frame3DGadget(#PB_Any, 10, 250, 180, 180, "Textfluss")
  TextGadget(#PB_Any, 20, 284, 70, 16, "X:") : StringGadget(#Gadget_Outlay_X, 100,280,80,20,"")
  TextGadget(#PB_Any, 20, 314, 70, 16, "Y:") : StringGadget(#Gadget_Outlay_Y, 100,310,80,20,"")
  TextGadget(#PB_Any, 20, 344, 70, 16, "Width:") : StringGadget(#Gadget_Outlay_Width, 100,340,80,20,"")
  TextGadget(#PB_Any, 20, 374, 70, 16, "Height:") : StringGadget(#Gadget_Outlay_Height, 100,370,80,20,"")
 
 ImageGadget(#Gadget_ImageView, 10, 460, 0, 0, 0, #PB_Image_Border)
 
Procedure UpdateView() 
 If TypefaceCharacterSet\Sprite3D : FreeImage(TypefaceCharacterSet\Sprite3D) : EndIf
 TypefaceCharacterSet\Sprite3D = CopyImage(TypefaceCharacterSet\Sprite, #PB_Any)
 With TypefaceCharacterSet\Character[GlobalIndex] 
  StartDrawing(ImageOutput(TypefaceCharacterSet\Sprite3D))
   DrawingMode(#PB_2DDrawing_AlphaBlend|#PB_2DDrawing_Outlined)
   Box(\Source\x-1, \Source\y-1, \Source\Width+2, \Source\Height+2, $800000FF)
   Box(\Source\x-\Outlay\x, \Source\y-\Outlay\y, \Outlay\Width, \Outlay\Height, $80FF0000)
  StopDrawing()
  GrabImage(TypefaceCharacterSet\Sprite3D, #Image_CharView, \Source\x, \Source\y, \Source\Width, \Source\Height)
  ResizeImage(#Image_CharView, ImageWidth(#Image_CharView)*2, ImageHeight(#Image_CharView)*2, #PB_Image_Raw)
 EndWith
 SetGadgetState(#Gadget_Image, ImageID(TypefaceCharacterSet\Sprite3D))
 SetGadgetState(#Gadget_ImageView, ImageID(#Image_CharView))
EndProcedure
 
Repeat

 Event = WaitWindowEvent()
 
 Select Event
 
  Case #PB_Event_CloseWindow
   End
 
  Case #PB_Event_Gadget
   Select EventGadget()
    Case #Gadget_Index
     If GetGadgetState(#Gadget_Index) > -1
      GlobalIndex = Val(GetGadgetText(#Gadget_Index))
      With TypefaceCharacterSet\Character[GlobalIndex] 
       SetGadgetText(#Gadget_Source_X, Str(\Source\x))
       SetGadgetText(#Gadget_Source_Y, Str(\Source\y))
       SetGadgetText(#Gadget_Source_Width, Str(\Source\Width))
       SetGadgetText(#Gadget_Source_Height, Str(\Source\Height))
       SetGadgetText(#Gadget_Outlay_X, Str(\Outlay\x))
       SetGadgetText(#Gadget_Outlay_Y, Str(\Outlay\y))
       SetGadgetText(#Gadget_Outlay_Width, Str(\Outlay\Width))
       SetGadgetText(#Gadget_Outlay_Height, Str(\Outlay\Height))
      EndWith
      UpdateView() 
     EndIf
    Case #Gadget_Source_X
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Source\x = ValF(GetGadgetText(#Gadget_Source_X))
      UpdateView()
     EndIf
    Case #Gadget_Source_Y
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Source\y = ValF(GetGadgetText(#Gadget_Source_Y))
      UpdateView()
     EndIf
    Case #Gadget_Source_Width
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Source\Width = ValF(GetGadgetText(#Gadget_Source_Width))
      UpdateView()
     EndIf
    Case #Gadget_Source_Height
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Source\Height = ValF(GetGadgetText(#Gadget_Source_Height))
      UpdateView()
     EndIf
    Case #Gadget_Outlay_X
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Outlay\x = ValF(GetGadgetText(#Gadget_Outlay_X))
      UpdateView()
     EndIf
    Case #Gadget_Outlay_Y
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Outlay\y = ValF(GetGadgetText(#Gadget_Outlay_Y))
      UpdateView()
     EndIf
    Case #Gadget_Outlay_Width
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Outlay\Width = ValF(GetGadgetText(#Gadget_Outlay_Width))
      UpdateView()
     EndIf
    Case #Gadget_Outlay_Height
     If GlobalIndex
      TypefaceCharacterSet\Character[GlobalIndex]\Outlay\Height = ValF(GetGadgetText(#Gadget_Outlay_Height))
      UpdateView()
     EndIf
  EndSelect
 
  Case #PB_Event_Menu
   Select EventMenu()
    Case #MenuItem_Load
     FileName$ = OpenFileRequester("Importieren", "", "Typeface (*.tf) |*.tf", 1)
     If FileName$
      FileName$ = GetPathPart(FileName$)+GetNamePart(FileName$)+".tf"
      ClearStructure(TypefaceCharacterSet, TypefaceCharacterSet)
      ReadFile(#File, FileName$)
       ReadQuad(#File)
       Index = ReadWord(#File)
       ClearGadgetItems(#Gadget_Index)
       While Index
        With TypefaceCharacterSet\Character[Index]
         \Exists = #True
         AddGadgetItem(#Gadget_Index, -1, Str(Index))
         \Outlay\x = ReadWord(#File)
         \Outlay\y = ReadWord(#File)
         \Outlay\Width = ReadWord(#File)
         \Outlay\Height = ReadWord(#File)
         \Source\x = ReadWord(#File)
         \Source\y = ReadWord(#File)
         \Source\Width = ReadWord(#File)
         \Source\Height = ReadWord(#File)
        EndWith
        Index = ReadWord(#File)
       Wend
       *Buffer = AllocateMemory(Lof(#File)-Loc(#File))
       ReadData(#File, *Buffer, Lof(#File)-Loc(#File))
       CatchImage(TypefaceCharacterSet\Sprite, *Buffer)
       SetGadgetState(#Gadget_Image, ImageID(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerWidth, ImageWidth(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerHeight, ImageHeight(TypefaceCharacterSet\Sprite))
      CloseFile(#File)
     EndIf    
    Case #MenuItem_Save
     FileName$ = SaveFileRequester("Exportieren", "", "Typeface (*.tf) |*.tf", 1)
     If FileName$ And TypefaceCharacterSet
      FileName$ = GetPathPart(FileName$)+GetNamePart(FileName$)+".tf"
      CreateFile(#File, FileName$)
       WriteQuad(#File, $7C30302E317C8354) ; Magische Zahl
       For Index = 1 To 255
        With TypefaceCharacterSet\Character[Index]
         If \Exists
          WriteWord(#File, Index)
          WriteWord(#File, \Outlay\x) : WriteWord(#File, \Outlay\y)
          WriteWord(#File, \Outlay\Width) : WriteWord(#File, \Outlay\Height)
          WriteWord(#File, \Source\x) : WriteWord(#File, \Source\y)
          WriteWord(#File, \Source\Width) : WriteWord(#File, \Source\Height)
         EndIf
        EndWith
       Next
       WriteWord(#File, 0)
       SaveImage(TypefaceCharacterSet\Sprite, GetTemporaryDirectory()+"Character.png", #PB_ImagePlugin_PNG)
       File = ReadFile(#PB_Any, GetTemporaryDirectory()+"Character.png")
        *Buffer = AllocateMemory(Lof(File))
        ReadData(File, *Buffer, Lof(File))
        WriteData(#File, *Buffer, Lof(File))
       CloseFile(File)
      CloseFile(#File)
     EndIf   
    Case #MenuItem_New
     If FontRequester("Arial", 12, #PB_FontRequester_Effects)
      If CreateTypeface()
       SetGadgetState(#Gadget_Image, ImageID(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerWidth, ImageWidth(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerHeight, ImageHeight(TypefaceCharacterSet\Sprite))
      EndIf
     EndIf
    Case #MenuItem_Import
     ClearStructure(TypefaceCharacterSet, TypefaceCharacterSet)
     FileName$ = OpenFileRequester("Importieren", "", "XML mit PNG |*.xml", 1)
     If FileName$
      FileName$ = GetPathPart(FileName$)+GetNamePart(FileName$) 
      If LoadXML(#XML, FileName$+".xml")
       *Node = MainXMLNode(#XML)
       TypefaceCharacterSet\Sprite = LoadImage(#PB_Any, GetXMLAttribute(*Node, "FileName"))
       ClearGadgetItems(#Gadget_Index)
       SetGadgetState(#Gadget_Image, ImageID(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerWidth, ImageWidth(TypefaceCharacterSet\Sprite))
       SetGadgetAttribute(#Gadget_ImageArea, #PB_ScrollArea_InnerHeight, ImageHeight(TypefaceCharacterSet\Sprite))
       *SubNode = ChildXMLNode(*Node)
       While *SubNode
        Index = Val(GetXMLAttribute(*SubNode, "Index"))
        With TypefaceCharacterSet\Character[Index]
         \Exists = 1
         AddGadgetItem(#Gadget_Index, -1, Str(Index))
         *SubSubNode = XMLNodeFromPath(*SubNode, "Outlay")
         \Outlay\x = ValF(GetXMLAttribute(*SubSubNode, "X"))
         \Outlay\y = ValF(GetXMLAttribute(*SubSubNode, "Y"))
         \Outlay\Width = ValF(GetXMLAttribute(*SubSubNode, "Width"))
         \Outlay\Height = ValF(GetXMLAttribute(*SubSubNode, "Height"))
         *SubSubNode = XMLNodeFromPath(*SubNode, "Source")
         \Source\x = ValF(GetXMLAttribute(*SubSubNode, "X"))
         \Source\y = ValF(GetXMLAttribute(*SubSubNode, "Y"))
         \Source\Width = ValF(GetXMLAttribute(*SubSubNode, "Width"))
         \Source\Height = ValF(GetXMLAttribute(*SubSubNode, "Height"))
        EndWith 
        *SubNode = NextXMLNode(*SubNode)
       Wend
       FreeXML(#XML)
      EndIf
     EndIf
    Case #MenuItem_Export
     FileName$ = SaveFileRequester("Exportieren", "", "XML mit PNG |*.xml", 1)
     If FileName$ And TypefaceCharacterSet
      FileName$ = GetPathPart(FileName$)+GetNamePart(FileName$)
      SaveImage(TypefaceCharacterSet\Sprite, FileName$+".png", #PB_ImagePlugin_PNG)
      CreateXML(#XML)
       *Node = CreateXMLNode(RootXMLNode(#XML))
       SetXMLNodeName(*Node, "Typeface") 
       SetXMLAttribute(*Node, "FileName", GetNamePart(FileName$)+".png")
       For Index = 0 To 255
        With TypefaceCharacterSet\Character[Index]
         If \Exists
          *SubNode = CreateXMLNode(*Node)
          SetXMLNodeName(*SubNode, "Character")
          SetXMLAttribute(*SubNode, "Index", Str(Index))
          *SubSubNode = CreateXMLNode(*SubNode)
          SetXMLNodeName(*SubSubNode, "Source")
          SetXMLAttribute(*SubSubNode, "X", Str(\Source\x))  
          SetXMLAttribute(*SubSubNode, "Y", Str(\Source\y))  
          SetXMLAttribute(*SubSubNode, "Width", Str(\Source\Width))  
          SetXMLAttribute(*SubSubNode, "Height", Str(\Source\Height))  
          *SubSubNode = CreateXMLNode(*SubNode)
          SetXMLNodeName(*SubSubNode, "Outlay")
          SetXMLAttribute(*SubSubNode, "X", Str(\Outlay\x))  
          SetXMLAttribute(*SubSubNode, "Y", Str(\Outlay\y))  
          SetXMLAttribute(*SubSubNode, "Width", Str(\Outlay\Width))  
          SetXMLAttribute(*SubSubNode, "Height", Str(\Outlay\Height))  
         EndIf        
        EndWith
       Next       
       FormatXML(#XML, #PB_XML_ReFormat)
      SaveXML(#XML, FileName$+".xml")
     EndIf 
   EndSelect
 
 EndSelect

ForEver
; IDE Options = PureBasic 4.51 RC 2 (Windows - x86)
; CursorPosition = 42
; EnableXP